JAVAC_HOME=`which javac`
ADA2JAVA_HOME=`which ada2java`
GNAT_HOME=`which gnat`

JAVAC_HOME=`dirname $JAVAC_HOME`
ADA2JAVA_HOME=`dirname $ADA2JAVA_HOME`
GNAT_HOME=`dirname $GNAT_HOME`

if [ `uname -o` = "Darwin" ]; then
  is_darwin="true";
else
  is_darwin="false";
fi

if [ "$is_darwin" = "true" ]; then
  JVM_LIB="/System/Library/Frameworks/JavaVM.framework/Libraries/"
else
  JVM_LIB=`find $JAVAC_HOME/.. | grep server/libjvm.so` 
  JVM_LIB=`dirname $JVM_LIB`
fi

# Environment variables

ADA_PROJECT_PATH=$ADA2JAVA_HOME/../lib/gnat:$ADA_PROJECT_PATH
CLASSPATH=$ADA2JAVA_HOME/../lib/ajis.jar:$CLASSPATH
if [ "$is_darwin" = "true" ]; then
 DYLD_LIBRARY_PATH=binding/ada/lib:$ADA2JAVA_HOME/../lib:$GNAT_HOME/../lib:$JVM_LIB:$DYLD_LIBRARY_PATH
 echo $DYLD_LIBRARY_PATH
else
  LD_LIBRARY_PATH=binding/ada/lib:$ADA2JAVA_HOME/../lib:$GNAT_HOME/../lib:$JVM_LIB:$LD_LIBRARY_PATH
fi
LPATH=$JVM_LIB:$LPATH

# Makefile specific variables

BUILD_CLASSPATH=src_java:binding/java:$CLASSPATH
RUN_CLASSPATH=bin:$CLASSPATH

export ADA_PROJECT_PATH CLASSPATH BUILD_CLASSPATH RUN_CLASSPATH LPATH
if [ "$is_darwin" = "true" ]; then
  export DYLD_LIBRARY_PATH
else
  export LD_LIBRARY_PATH
fi

make $1

